oi..<?php 
/* vim: set expandtab tabstop=4 shiftwidth=4: */ 
// +----------------------------------------------------------------------+ 
// | PHP version 4 - SAM Reports!                                         | 
// +----------------------------------------------------------------------+ 
// | Copyright (c) 1997-2003 The PHP Group                                | 
// +----------------------------------------------------------------------+ 
// | This source file is subject to version 2.0 of the PHP license,       | 
// | that is bundled with this package in the file LICENSE, and is        | 
// | available through the world-wide-web at                              | 
// | http://www.php.net/license/2_02.txt.                                 | 
// | If you did not receive a copy of the PHP license and are unable to   | 
// | obtain it through the world-wide-web, please send a note to          | 
// | license@php.net so we can mail you a copy immediately.               | 
// +----------------------------------------------------------------------+ 
// | Authors: Marcelo Pereira Fonseca da Silva <marcelopfs@yahoo.com.br   | 
// +----------------------------------------------------------------------+ 
// $ Id : 0.3 obrigado ao jpm pela explicao sobre classes

Class Restrito {

    /**
     * Arzemana as palavras proibidas
     * 
     * @access public 
     */
    var $addItem = array();

    /**
     * Frase que ser analisada
     *
     * @access public
     */
    var $frase;

    /**
     * String final
     *
     * @acces public
     */
    var $parsed;

    /**
     * Caractere que ser usado no lugar do palavro
     *
     * @access public
     */
    var $char;

    /**
     * Define o texto que ser analisado
     *
     * @access public
     * @param String $string Contm a string que ser analisada
     */
    function set($string) {
        $this->frase = strtolower($string);
    }

    /**
     * Analisa a string retornando as palavras proibidas
     *
     * @access public 
     * @return String $parsed Contm a string analisada
     */
    function parse() {

        $explode = explode(" ", $this->frase);
        $tamanho = sizeof($explode); 

        for ($x=0;$x<$tamanho;$x++) 
            { 
                if (!isset($this->char)) 
                    $this->char = "*";

                if (in_array($explode[$x], array_change_key_case($this->addItem, CASE_LOWER))) {                   
                    for ($y=0;$y<strlen($explode[$x]);$y++) {  
                        $xstr .= $this->char; 
                    }

                    $valor_final = " " . $xstr;
                } else { 
                    $valor_final = " " . $explode[$x]; 
                }
                
                $string_final .= $valor_final; 
                unset($xstr);
            } 

        $this->parsed = $string_final;
        
        return $this->parsed;
    }

    function display() {
        echo $this->parsed;
    }

    /**
     * Adiciona uma palavra  lista de palavras proibidas
     *
     * @access public
     * @param String $item Palavra que no pode estar na string que ser analisada
     */
    function _addword($item) {
        $this->addItem = $item;
    }

    /**
     * Retorna o caractere que ser colocado no lugar da palavra
     *
     * @access public
     * @param String $char Contm o caractere para troca 
     */
    function setchar($char) 
    {
        $this->char = $char;
    }
}

?>
